package com.biganto.visual.roompark.presentation.screen.article

import android.content.Context
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.PerScreen
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module


@PerScreen
@Component(
    modules = [ArticleScreenModule::class],
    dependencies = [AppComponent::class])
interface ArticleScreenComponent {

    @Component.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ): ArticleScreenComponent
    }

    val presenter: ArticleScreenPresenter

    fun inject(controller: ArticleScreenController)
}

@Module
abstract class ArticleScreenModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context

}
